# -*- encoding: utf-8 -*-
##############################################################################
#
#    Addition to OpenERP, Open Source Management Solution   
#    Copyright (C) 2004-2012 Vertel. All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


{
    'name': 'Fleet Management System',
    'version': '0.8',
    'category': 'Vertical Modules/Fleet Management',
    'description': """Management of a fleet of vehicles, fleet cards and 
    service planning.
 - Viechle
     * Odometer log
     * Fuel log
     * Work order
 - Fleet Card 
 
Vehicles can be owned, leased or hired and the economic analyses such cost 
per mile will be correct. Fuel Logs are held and services are planned if 
its relevant for the type of ownership of the vehicle. 

Odometer readings can be done in miles or hours with 
details that in some countries are mandatory for authority reporting. 
Use the location so that the spares, tyres etc are assossiated with the 
vehicle when issued. If you have income from the vehicle you can analyse 
how it compares to costs and calculate a revenue.

Compare and analyse your service vendors and vehicle suppliers.
 
Use fms_asset to get a correct deprecration. Fms_damage_log to get a better 
insurance and incident management. Fms_Drivers_log are a combination of 
fuel and odometer log. Fleet Cards management and fuel log matching of purchase invoices.  


The module is a vertical for fleet operations management inspired by 
Sharoon Thomas module fleet_manager

TODO
====

* Spares when creating a Work Order
* Purschase spares as an button on WO
* Drivers Log
* Manual service order, note, service model cannot be mandatory 

""",
    'author': 'Vertel',
    'website': 'http://www.vertel.se',
    'depends': ['account','stock_location','card'],
    'init_xml': [],
    'update_xml': ['board_fms_view.xml','fms_menu.xml','fms_view.xml','fms_sequence.xml','fms_workflow.xml',
                   'fms_odometer_view.xml','fms_service_view.xml','fms_expenses_view.xml','fms_fleet_card_view.xml',
                   'account_invoice_view.xml','account_data.xml',
                   'fms_fuellog_view.xml','fms_fuellog_data.xml',
                   'security/fms_security.xml','security/ir.model.access.csv','fms_installer.xml'],
    'demo_xml': [],
    'installable': True,
    'active': False,
    'application': True,
}
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
