# -*- encoding: utf-8 -*-
##############################################################################
#
#    Addition to OpenERP, Open Source Management Solution   
#    Copyright (C) 2004-2012 Vertel. All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
from tools.translate import _

class account_invoice(osv.osv):
    _inherit = 'account.invoice'
    
    def action_move_create(self, cr, uid, ids, *args):    
        for inv in self.browse(cr, uid, ids):
            vehicle_id = self.pool.get('account.invoice.line').fms_vehicle_create(cr, uid, inv.invoice_line)
        result = super(account_invoice, self).action_move_create(cr, uid, ids, *args)
        return result

    
    def action_number(self, cr, uid, ids, *args):
        result = super(account_invoice, self).action_number(cr, uid, ids, *args)
        for inv in self.browse(cr, uid, ids):        
            for line in inv.invoice_line:
                if line.fms_create == True:
                    self.pool.get('fms.vehicles').log(cr, uid, line.vehicle_id.id, _("Created new vehicle from %s") % inv.number)
        #for inv in self.browse(cr, uid, ids):
            #self.pool.get('account.invoice.line').mdm_device_create(cr, uid, inv.invoice_line)
        return result

    #def line_get_convert(self, cr, uid, x, part, date, context=None):
        #res = super(account_invoice, self).line_get_convert(cr, uid, x, part, date, context=context)
        #res['device_id'] = x.get('device_id', False)
        #return res

account_invoice()

class account_invoice_line(osv.osv):
    _inherit = 'account.invoice.line'
    _columns = {
        'vehicle_id': fields.many2one('fms.vehicles', 'Vehicle Id'),
        'fms_create': fields.boolean('New Vehicle', help='Check this field if this line is a vehicle and you want to register it as a new. Use Analytic Account for additional costs'),
        'fms_name':fields.char('Regno',size=10),
        'fms_make':fields.char('Make',size=10),
        'fms_model':fields.char('Model',size=15),
    }
    def fms_vehicle_create(self, cr, uid, lines, context=None):
        context = context or {}
        res = {}
        for line in lines:
            if line.fms_create == True:
                vehicle_id = self.pool.get('fms.vehicles').create(cr, uid, {
                        'name': line.fms_name,
                        'make': line.fms_make,
                        'model': line.fms_model,
                        'description': line.name,
                        'pinvoice': line.invoice_id.id,
                        'pcost': line.price_subtotal,
                        'partner_id': line.invoice_id.partner_id.id,
                        'company_id': line.invoice_id.company_id.id,
                }, context=context)
                vehicle = self.pool.get('fms.vehicles').browse(cr, uid,vehicle_id,context=context)
                self.pool.get('account.invoice.line').write(cr,uid,line.id,{
                    'vehicle_id': vehicle.id,
                    'account_analytic_id': vehicle.analytic_account_id.id,
                    },context=context)
                self.log(cr, uid, line.id, _("Created new vehicle %s") % vehicle.name)
                res[line.id] = vehicle.id
        return res
account_invoice_line()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
