# -*- encoding: utf-8 -*-
##############################################################################
#
#    Addition to OpenERP, Open Source Management Solution   
#    Copyright (C) 2004-2012 Vertel. All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
import pooler
import time
import datetime
from tools.translate import _               

       
                
class fms_expenses(osv.osv):
    """FMS expenses are a kind of card expenses that adds information about
    the vehicle
    """
    _name = "fms.expenses"
    _description = "Records expenses entries"
    _inherits = {'card.expenses': "expenses_id"}

    _columns = {

# analytic

#        'name': fields.char('Description', size=256, required=True),
#        'date': fields.date('Date', required=True, select=True),
#        'amount': fields.float('Amount', required=True, help='Calculated by multiplying the quantity and the price given in the Product\'s cost price. Always expressed in the company main currency.', digits_compute=dp.get_precision('Account')),
#        'unit_amount': fields.float('Quantity', help='Specifies the amount of quantity to count.'),
#        'account_id': fields.many2one('account.analytic.account', 'Analytic Account', required=True, ondelete='cascade', select=True, domain=[('type','<>','view')]),
#        'user_id': fields.many2one('res.users', 'User'),
#        'company_id': fields.related('account_id', 'company_id', type='many2one', relation='res.company', string='Company', store=True, readonly=True),

# account / account_analytic_line.py
#        'product_uom_id': fields.many2one('product.uom', 'UoM'),
#        'product_id': fields.many2one('product.product', 'Product'),
#        'general_account_id': fields.many2one('account.account', 'General Account', required=True, ondelete='restrict'),
#        'move_id': fields.many2one('account.move.line', 'Move Line', ondelete='cascade', select=True),
#        'journal_id': fields.many2one('account.analytic.journal', 'Analytic Journal', required=True, ondelete='restrict', select=True),
#        'code': fields.char('Code', size=8),
#        'ref': fields.char('Ref.', size=64),
#        'currency_id': fields.related('move_id', 'currency_id', type='many2one', relation='res.currency', string='Account currency', store=True, help="The related account currency if not equal to the company one.", readonly=True),
#        'amount_currency': fields.related('move_id', 'amount_currency', type='float', string='Amount currency', store=True, help="The amount expressed in the related account currency if not equal to the company one.", readonly=True),

# card.expenses    
                #'cardno':       fields.many2one('card.card','Payment Card',required=True,readonly=True, states={'draft':[('readonly',False)]}),
                #'analytic_account_line': fields.many2one('account.analytic.line', 'Analytic Account Line', ondelete="cascade", required=False),                
                #'period_id':    fields.many2one('account.period','Period',required=True,readonly=True, states={'draft':[('readonly',False)]}),
                #'line_id':      fields.many2one('account.invoice.line','Invoice Line',required=False,readonly=True),
                #'note':         fields.text('Note'),
                #'type':         fields.many2one('card.expenses.type','Type',required=True),
                #'state':        fields.selection([
                                          #('draft','Draft'),
                                          #('approved','Approved'),
                                          #('payed','Payed'),
                                          #('cancel','Cancel'),
                                          #],readonly=True),

                #'instructions': fields.related('type','instructions',type="text",string="Instructions",readonly=True),
                #'partner_id':   fields.related('cardno','partner_id',type="many2one",string="Issuer"),
                #'date_valid':   fields.related('cardno','date_valid',type="date",string="Valid Thru"),
                #'log':          fields.function(_get_user_messages,string='History',method=True,type = 'one2many',relation='res.log',),
                #'invoice_id':   fields.function(_get_invoice_id,string='Invoice',method=True,type = 'char',size=25),

                'expenses_id': fields.many2one('card.expenses', 'Expense', required=True, ondelete='cascade', select=True, readonly=True, states={'draft':[('readonly',False)]}),
                'vehicle_id': fields.many2one('fms.vehicles', 'Vehicle', required=True, ondelete='cascade', select=True, readonly=True, states={'draft':[('readonly',False)]}),
                'odometer':fields.integer('Odometer',required=True,readonly=True, states={'draft':[('readonly',False)]}),

#                'qty':fields.float('Quantity',digits=(4,2),required=True,readonly=True, states={'draft':[('readonly',False)]}),
#                'totalcost':fields.float('Total Cost',digits=(16,2),required=True,readonly=True, states={'draft':[('readonly',False)]}),


                }
    _defaults = {
        'state': lambda *a:'draft',
#        'ref': lambda obj,cr,uid,context: obj.pool.get('ir.sequence').get(cr,uid,'fms.fuel'),
    }



    def button_payed(self, cr, uid, ids, context=None):
        fmsexp = self.pool.get('fms.expenses').browse(cr, uid, ids[0])
        self.pool.get('card.expenses').log(cr, uid, fmsexp.expenses_id.id, "Expense manualy %s payed" % self.browse(cr,uid,ids[0]).ref)
        return self.write(cr, uid, ids, {'state': 'payed'})
    def button_approved(self, cr, uid, ids, context=None):
        fmsexp = self.pool.get('fms.expenses').browse(cr, uid, ids[0])
        self.pool.get('card.expenses').log(cr, uid, fmsexp.expenses_id.id, "Expense %s approved" % self.browse(cr,uid,ids[0]).ref)
        return self.write(cr, uid, ids, {'state': 'approved'})
    def button_draft(self, cr, uid, ids, context=None):
        self.log(cr, uid, ids[0], "Expense %s in draft" % self.browse(cr,uid,ids[0]).ref)
        return self.write(cr, uid, ids, {'state': 'draft'})
    def button_cancel(self, cr, uid, ids, context=None):
        return self.write(cr, uid, ids, {'state': 'cancel'})

    def on_change_unit_amount(self, cr, uid, id, prod_id, quantity, company_id, unit=False, journal_id=False, context=None):
        try:
            expenses = self.pool.get('fms.expenses').browse(cr, uid, id)[0]
            return expenses.account_analytic_line.on_change_unit_amount(cr, uid, expenses.analytic_account_line.id,prod_id,quantity,company_id,unit,journal_id,context)
        except:
            return {'value': {'amount': 1.0,}}

    def onchange_type(self, cr, uid, id, type_id=False,context=False):
        return self.pool.get('card.expenses').onchange_type(cr, uid,id ,type_id,context) # dont use id

    def onchange_cardno(self, cr, uid, id, cardno=False,context=False):
        return self.pool.get('card.expenses').onchange_cardno(cr, uid,id ,cardno,context) # dont use id


    def onchange_vehicle(self, cr, uid, id, vehicle_id=False,context=False):
        val = {}
        vehicle = self.pool.get('fms.vehicles').browse(cr, uid, vehicle_id)
        if vehicle:
            val['account_id']   =  vehicle.analytic_account_id.id
            val['odometer']     =  vehicle.lodometer
            val['podometer']    =  vehicle.lodometer
        return {'value': val}

fms_expenses()


class fms_vehicles(osv.osv):
    _name = "fms.vehicles"
    _inherit = "fms.vehicles"

    def last_lodometer(self,cr,uid,vehicle,context=None):
        res = super(fms_vehicles,self).last_lodometer(cr,uid,vehicle,context)
        lastfl_id = self.pool.get('fms.expenses').search(cr, uid, [('vehicle_id','=',vehicle.id)])
        if len(lastfl_id) > 0:
            for lastfl in self.pool.get('fms.expenses').browse(cr, uid, lastfl_id, context=context):
                if lastfl.date > res['bdate']:
                    res['bdate'] = lastfl.date
                if res['lodometer'] < lastfl.odometer:
                    res['lodometer'] = int(lastfl.odometer)            
        return res
    

fms_vehicles()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
