# -*- encoding: utf-8 -*-
##############################################################################
#
#    Addition to OpenERP, Open Source Management Solution   
#    Copyright (C) 2004-2012 Vertel. All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
import pooler
import time
import datetime
from tools.translate import _               


class fms_fuellog(osv.osv):
    """Fuellog are a kind of expenses. A fuellog adds information about the
    vehicle such as odometer and about the fuel.
    """
    _name = "fms.fuellog"
    _description = "Records the fuelling entries"
    _inherits = {'fms.expenses': 'fms_expenses_id'}


    def _get_type(self, cr, uid, context):
#        raise osv.except_osv(_('Fuel account missing !'), _('You have to register a standard accunt for fuel log for the company %s') % self.pool.get('res.company').browse(cr,uid,self.pool.get('res.company')._company_default_get(cr, uid, 'fms.fuellog', context=context),context).fms_fuellog_type.id )
        if not self.pool.get('res.company').browse(cr,uid,self.pool.get('res.company')._company_default_get(cr, uid, 'fms.fuellog', context=context),context).fms_fuellog_type:
            raise osv.except_osv(_('Fuel account missing !'), _('You have to register a standard accunt for fuel log for the company') )
        return self.pool.get('res.company').browse(cr,uid,self.pool.get('res.company')._company_default_get(cr, uid, 'fms.fuellog', context=context),context).fms_fuellog_type.id

    def _get_general_account(self, cr, uid, context=None):
#        return type_id.account_id.id
#        raise osv.except_osv(_('Wrong description !'), _('You have a wrong expression "%s"') % type_id)
        account = self.pool.get('card.expenses.type').browse(cr,uid,self._get_type(cr,uid,context),context)
        if account and account.account_id and account.account_id.id: 
            return account.account_id.id
        else:
            return False

    def _get_unit_amount(self, cr, uid, context):
#        return 10
        raise osv.except_osv(_('Fuel account missing !'), _('context %s') % context)
        if not self.pool.get('res.company').browse(cr,uid,self.pool.get('res.company')._company_default_get(cr, uid, 'fms.fuellog', context=context),context).fms_fuellog_type:
            raise osv.except_osv(_('Fuel account missing !'), _('You have to register a standard accunt for fuel log for the company') )
        return self.pool.get('res.company').browse(cr,uid,self.pool.get('res.company')._company_default_get(cr, uid, 'fms.fuellog', context=context),context).fms_fuellog_type.id


    def _get_period(self, cr, uid, context):
        periods = self.pool.get('account.period').find(cr, uid)
        if periods:
            return periods[0]
        else:
            return False
    
        
    def calc_amount2(self,cr,uid,ids,field,unknown,context={}):
        res={}
        for obj in self.browse(cr,uid,ids):
            if obj.unit_amount:
                res[obj.id] = obj.amount/obj.unit_amount
            else:
                res[obj.id]=0.0
        return res
    def calc_pdate(self,cr,uid,ids,field,unknown,context={}):
        res={}
        for obj in self.browse(cr,uid,ids):
            if obj.qty:
                res[obj.id] = obj.amount/obj.qty
            else:
                res[obj.id]=0.0
        return res

    def calc_pdate(self, cr, uid, ids, field_name, arg, context=None):
        res = {}
        for fl in self.browse(cr, uid, ids, context=context):
            lastfl_id = self.pool.get('fms.fuellog').search(cr, uid, [('odometer','<',fl.odometer),('vehicle_id','=',fl.vehicle_id.id)])
            res[fl.id] = {
                'pdate': fl.vehicle_id.pdate or 0,
                'podometer': fl.vehicle_id.podometer,
                'lmiles': 0.0,
                'costpm': 0.0,
                'litrepm': 0.0,
            }
            if len(lastfl_id) > 0:
                for lastfl in self.browse(cr, uid, lastfl_id, context=context):
                    if lastfl.date > res[fl.id]['pdate']:
                        res[fl.id]['pdate'] = lastfl.date
                    if res[fl.id]['podometer'] < lastfl.odometer:
                        res[fl.id]['podometer'] = lastfl.odometer
                        
            res[fl.id]['lmiles'] = fl.odometer - res[fl.id]['podometer'] 
            if fl.amount > 0 and res[fl.id]['lmiles'] > 0:
                res[fl.id]['costpm'] = round(fl.amount / res[fl.id]['lmiles'],2) 
            if fl.unit_amount > 0 and res[fl.id]['lmiles'] > 0:
                res[fl.id]['litrepm'] = round(fl.unit_amount / res[fl.id]['lmiles'] * 10,1) 
        return res

    def copy(self, cr, uid, id, default=None,context={}):
        if not default:
            default = {}
        default.update({
            'state':'draft',
            'log_no': self.pool.get('ir.sequence').get(cr, uid, 'fms.fuel'),
        })
        return super(fms_fuellog, self).copy(cr, uid, id, default, context)

    _columns = {

# analytic

#        'name': fields.char('Description', size=256, required=True),
#        'date': fields.date('Date', required=True, select=True),
#        'amount': fields.float('Amount', required=True, help='Calculated by multiplying the quantity and the price given in the Product\'s cost price. Always expressed in the company main currency.', digits_compute=dp.get_precision('Account')),
#        'unit_amount': fields.float('Quantity', help='Specifies the amount of quantity to count.'),
#        'account_id': fields.many2one('account.analytic.account', 'Analytic Account', required=True, ondelete='cascade', select=True, domain=[('type','<>','view')]),
#        'user_id': fields.many2one('res.users', 'User'),
#        'company_id': fields.related('account_id', 'company_id', type='many2one', relation='res.company', string='Company', store=True, readonly=True),

# account / account_analytic_line.py
#        'product_uom_id': fields.many2one('product.uom', 'UoM'),
#        'product_id': fields.many2one('product.product', 'Product'),
#        'general_account_id': fields.many2one('account.account', 'General Account', required=True, ondelete='restrict'),
#        'move_id': fields.many2one('account.move.line', 'Move Line', ondelete='cascade', select=True),
#        'journal_id': fields.many2one('account.analytic.journal', 'Analytic Journal', required=True, ondelete='restrict', select=True),
#        'code': fields.char('Code', size=8),
#        'ref': fields.char('Ref.', size=64),
#        'currency_id': fields.related('move_id', 'currency_id', type='many2one', relation='res.currency', string='Account currency', store=True, help="The related account currency if not equal to the company one.", readonly=True),
#        'amount_currency': fields.related('move_id', 'amount_currency', type='float', string='Amount currency', store=True, help="The amount expressed in the related account currency if not equal to the company one.", readonly=True),

# card.expenses    
                #'cardno':       fields.many2one('card.card','Payment Card',required=True,readonly=True, states={'draft':[('readonly',False)]}),
                #'analytic_account_line': fields.many2one('account.analytic.line', 'Analytic Account Line', ondelete="cascade", required=False),                
                #'period_id':    fields.many2one('account.period','Period',required=True,readonly=True, states={'draft':[('readonly',False)]}),
                #'line_id':      fields.many2one('account.invoice.line','Invoice Line',required=False,readonly=True),
                #'note':         fields.text('Note'),
                #'type':         fields.many2one('card.expenses.type','Type',required=True),
                #'state':        fields.selection([
                                          #('draft','Draft'),
                                          #('approved','Approved'),
                                          #('payed','Payed'),
                                          #('cancel','Cancel'),
                                          #],readonly=True),

                #'instructions': fields.related('type','instructions',type="text",string="Instructions",readonly=True),
                #'partner_id':   fields.related('cardno','partner_id',type="many2one",string="Issuer"),
                #'date_valid':   fields.related('cardno','date_valid',type="date",string="Valid Thru"),
                #'log':          fields.function(_get_user_messages,string='History',method=True,type = 'one2many',relation='res.log',),
                #'invoice_id':   fields.function(_get_invoice_id,string='Invoice',method=True,type = 'char',size=25),





#                'vehicle_id': fields.many2one('fms.vehicles', 'Vehicle', required=True, ondelete='cascade', select=True, readonly=True, states={'draft':[('readonly',False)]}),
#                'odometer':fields.integer('Odometer',required=True,readonly=True, states={'draft':[('readonly',False)]}),

#                'qty':fields.float('Quantity',digits=(4,2),required=True,readonly=True, states={'draft':[('readonly',False)]}),
#                'totalcost':fields.float('Total Cost',digits=(16,2),required=True,readonly=True, states={'draft':[('readonly',False)]}),

                'fms_expenses_id': fields.many2one('fms.expenses', 'FMS Expenses', ondelete="cascade", required=True),                
                'costpl':fields.function(calc_amount2,method=True,string='Cost Per Ltr',digits=(16,2),store=True),
                'costpm':fields.function(calc_pdate,string='Cost Per Mile',digits=(16,2),type='float',multi="costpm"),
                'litrepm':fields.function(calc_pdate,string='l/100km',digits=(3,1),type='float',multi="litrepm"),
                'lmiles':fields.function(calc_pdate,string='Miles',type='integer',multi="lmiles"),
                'pdate':fields.function(calc_pdate,string='Prev date',type='date',multi="pdate"),
                'podometer':fields.function(calc_pdate,string='Prev Odometer',type="integer",multi="odometer"),                

                }
    _defaults = {
        'name': _('Fuel log expense'),
        'state': 'draft',
        'ref': lambda obj,cr,uid,context: obj.pool.get('ir.sequence').get(cr,uid,'fms.fuel'),
        'type': _get_type,
        'general_account_id': _get_general_account,
#        'unit_amount' : _get_unit_amount,
    }

    def button_payed(self, cr, uid, ids, context=None):
#        self.log(cr, uid, ids[0], "Here I come %s" % self.browse(cr,uid,ids[0]).name)
        return self.write(cr, uid, ids, {'state': 'payed'})
    def button_draft(self, cr, uid, ids, context=None):
        return self.write(cr, uid, ids, {'state': 'draft'})
    def button_cancel(self, cr, uid, ids, context=None):
        return self.write(cr, uid, ids, {'state': 'cancel'})

    def on_change_unit_amount(self, cr, uid, id, prod_id, quantity, company_id, unit=False, journal_id=False, context=None):
        try:
            fuellog = self.pool.get('fms.fuellog').browse(cr, uid, id)[0]
            return {'value': {'amount': fuellog.costpl * quantity,}}
        except:
            return {'value': {'amount': 1.0,}}

    def calc_amount(self,cr,uid,ids,totalcost,qty):
        res={}
        if qty:
            res['costpl'] = totalcost/qty
        else:
            res['costpl']=0.0
        return {'value':res}

    def onchange_type(self, cr, uid, id, type_id=False,context=False):
        try:
            fuellog = self.pool.get('fms.fuellog').browse(cr, uid,id)[0]
            expenses_id = fuellog.expenses_id.id
        except:
            expenses_id = None
        return self.pool.get('card.expenses').onchange_type(cr, uid,expenses_id ,type_id,context)

    def onchange_cardno(self, cr, uid, id, cardno=False,context=False):
        try:
            fuellog = self.pool.get('fms.fuellog').browse(cr, uid,id)[0]
            expenses_id = fuellog.expenses_id.id
        except:
            expenses_id = None
        return self.pool.get('card.expenses').onchange_cardno(cr, uid,expenses_id ,cardno,context)

    def onchange_vehicle(self, cr, uid, id, vehicle_id=False,context=False):
        val = {}
        ret = self.pool.get('fms.expenses').onchange_vehicle(cr, uid,id ,vehicle_id,context)
        if ret['value']:
            val = ret['value']
        vehicle = self.pool.get('fms.vehicles').browse(cr, uid, vehicle_id)
        if vehicle:
            val['unit_amount']  =  round(vehicle.fueltankcap * 0.9)
            val['podometer']    =  vehicle.lodometer
            val['amount']       =  vehicle.fcostpl * int(val['unit_amount'])
            val['costpm']       =  vehicle.fcostpm 
            val['litrepm']       =   vehicle.litrepm
            if vehicle.litrepm > 0:
                val['odometer']     =  vehicle.lodometer + (round(val['unit_amount'] / vehicle.litrepm) * 10)
                val['lmiles']       =  round(val['unit_amount'] / vehicle.litrepm) * 10

        return {'value': val}

fms_fuellog()



class fms_vehicles(osv.osv):
    _name = "fms.vehicles"
    _inherit = "fms.vehicles"

    def last_lodometer(self,cr,uid,vehicle,context=None):
        res = super(fms_vehicles,self).last_lodometer(cr,uid,vehicle,context)
        lastfl_id = self.pool.get('fms.fuellog').search(cr, uid, [('vehicle_id','=',vehicle.id)])
        if len(lastfl_id) > 0:
            for lastfl in self.pool.get('fms.fuellog').browse(cr, uid, lastfl_id, context=context):
                if lastfl.date > res['bdate']:
                    res['bdate'] = lastfl.date
                if res['lodometer'] < lastfl.odometer:
                    res['lodometer'] = int(lastfl.odometer)            
        return res
    
    def _amount_fuellog(self, cr, uid, ids, field_name, arg, context=None):
        res = {}
        for vehicle in self.browse(cr, uid, ids, context=context):
            lastfl_id = self.pool.get('fms.fuellog').search(cr, uid, [('vehicle_id','=',vehicle.id)],order="date desc")
            res[vehicle.id] = {
                'totfcost': 0.0,
                'fcostpm': 0.0,
                'litrepm': 0.0,
                'litrepmtrend': 0.0,
                'qty': 0.0,
            }
            
            count = qty_trend = distance_trend_from = distance_trend_to = 0
            #raise osv.except_osv(_('Invalid action !'), _('vals! %s | %s') % (self._lodometer,vehicle.bdate),)

            if len(lastfl_id) > 0:
                for lastfl in self.pool.get('fms.fuellog').browse(cr, uid, lastfl_id, context=context):
                    if count == 0:
                        distance_trend = lastfl.odometer
                    if count > 1 and count < 5:
                        qty_trend += lastfl.unit_amount
                        distance_trend_to = lastfl.odometer
                    res[vehicle.id]['qty'] += lastfl.unit_amount
                    res[vehicle.id]['totfcost'] += lastfl.amount
                if res[vehicle.id]['qty'] > 0 and vehicle.distance > 0:
                    res[vehicle.id]['litrepm'] = round(res[vehicle.id]['qty'] / vehicle.distance * 10,2)
                    res[vehicle.id]['fcostpm'] = round(res[vehicle.id]['totfcost'] / vehicle.distance,2)
                    res[vehicle.id]['fcostpl'] = round(res[vehicle.id]['totfcost'] /  res[vehicle.id]['qty'],2)
                    try:
                        self.log(cr, uid, ids[0], "Trend %s %s %s" % (distance_trend_to,distance_trend_from,qty_trend))
                        res[vehicle.id]['litrepmtrend'] = ((qty_trend / (distance_trend_to - distance_trend_from) * 10) / res[vehicle.id]['litrepm'] ,2) 
                    except Exception:
                        res[vehicle.id]['litrepmtrend'] = 0
        return res

    _columns = {
                'fuellog': fields.one2many('fms.fuellog', 'vehicle_id', 'Fuel Log', readonly=False),
                'totfcost':fields.function(_amount_fuellog,string='Total fuel Cost',type = 'float',help="Fuel Cost from fuel log",multi="totfcost"),
                'fcostpm':fields.function(_amount_fuellog,string='Fuel Cost per mile',type = 'float',help="Fuel Cost from fuel log",multi="fcostpm"),
                'fcostpl':fields.function(_amount_fuellog,string='Fuel Cost per litre',type = 'float',help="Fuel Cost from fuel log",multi="fcostpl"),
                'litrepm':fields.function(_amount_fuellog,string='l/100km',type = 'float',help="Sum of latest fuel log recordings",multi="litrepm"),
                'litrepmtrend':fields.function(_amount_fuellog,string='l/100km trend',type = 'float',help="How fuel consumtion has changed",multi="litrepmtrend"),
                'qty':fields.function(_amount_fuellog,string='Qty',type = 'int',help="Quantity of fuel",multi="qty"),


                }
    
fms_vehicles()


class company(osv.osv):
    _inherit = 'res.company'
    _columns = {
        'fms_fuellog_type': fields.many2one('card.expenses.type','Fuel expenses type', required=True,
            help="This is the Card Expenses Type that are to be used in Fuellogs"),
    }
company()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
